//
//  CalculatorTest.m
//  SimpleCalculator
//
//  Created by Peter Hauke on 02.10.13.
//  Copyright (c) 2013 2sox. All rights reserved.
//

#import <XCTest/XCTest.h>
#import "Calculator.h"
@interface TestCalculator : XCTestCase

@end

@implementation TestCalculator

- (void)setUp {
    [super setUp];
    // Put setup code here; it will be run once, before the first test case.
    
}

- (void)tearDown {
    // Put teardown code here; it will be run once, after the last test case.
    [super tearDown];
}

-(void)testAddNumberToNumber {
    Calculator *testCalculator = [[Calculator alloc] init];
    
    NSNumber *resultAdd = [testCalculator addNumber:@(1) toNumber:@(2)];
    
    // So könnte man Testen, aber ...
    // - Nur in der Konsole wären fails zu erkennen
    if (![resultAdd isEqualToNumber:@(3)]) {
        NSLog(@"1 + 2 should be 3");
    }
    
    // Besser: über XCTAsserts ein validieren
    
    // Tests for correct math
    XCTAssertEqual(resultAdd.floatValue, 3.0f,
                   @"A famous guy taught us: 1+2=3, but in your universe is 1+2=%.0f",
                   resultAdd.floatValue);
    
    // tests for input != nil
    XCTAssertNil([testCalculator addNumber:nil toNumber:@(0)],
                 @"Result should be nil if first parameter is nil!");
	XCTAssertNil([testCalculator addNumber:@(0) toNumber:nil],
                 @"Result should be nil if second parameter is nil!");
	XCTAssertNil([testCalculator addNumber:nil toNumber:nil],
                 @"Result should be nil if parameters are nil!");
	XCTAssertNotNil([testCalculator addNumber:@(0) toNumber:@(0)],
                    @"Result should NOT be nil if parameters are not nil!");

};

@end
