//
//  Game+Methods.m
//  TicTacToe
//
//  Created by Kasprzak Ingo on 28.06.12.
//  Copyright (c) 2012 Silutions. All rights reserved.
//

#import "Game+Methods.h"
#import "Move+Methods.h"

struct Combo { // Gewinnkombinationen
    int field0; int field1; int field2;
};

@implementation Game (Methods)

- (NSSet*)checkForWinningCombo {
	// win combinations
    static struct Combo combos[] = {
		{0,1,2}, {3,4,5}, {6,7,8},
		{0,3,6}, {1,4,7}, {2,5,8},
		{0,4,8}, {2,4,6}
	};
	
	int comboCount = 8;
	
    // brute force parse for winning combinations in game 
	TicTacToeDatabase *database = [TicTacToeDatabase sharedTicTacToeDatabase];
	if ([self.winningCombo count]==0) {
		for (int i=0; i<comboCount; i++) {
			for (int player = 0; player<2; player++) {
				NSSet *match = [database fetchObjectsForEntityClass:[Move class] withPredicate:
								@"game=%@ AND player=%i AND (field=%i OR field=%i OR field=%i)",
								self, player, combos[i].field0, combos[i].field1, combos[i].field2
								];
				if ([match count] == 3) {
					[self addWinningCombo:match];
				}
			}
		}
		if (self.hasChanges) { [self.managedObjectContext save:nil]; }
	}
	return ([self.winningCombo count]>0) ? self.winningCombo : nil;
}

@end
