//
//  SynchronizationServerDelegate.h
//  TicTacToe
//
//  Created by Ingo Kasprzak on 11.10.12.
//  Copyright (c) 2012 Silutions. All rights reserved.
//

@import Foundation;

@class Device;

@protocol SynchronizationServerDelegate <NSObject>
@required
- (Device*)thisDevice;
- (void)receivedModifiedObjects:(NSSet*)objects;
- (void)receivedBidirectionalRequestAndModifiedObjects:(NSSet*)objects;

@optional
- (void)receivedReceiptForCommand:(NSString*)commandString
					   fromDevice:(NSString*)deviceUID
						 withDate:(NSString*)date;

- (void)receivedReceiptForCommand:(NSString*)ucid;
- (void)receivedIdentification:(NSString*)deviceUID fromPeer:(NSString*)peer;
- (void)receivedDisconnection:(NSString*)deviceUID fromPeer:(NSString*)peer;
@end
